/[gentoo-x86]/eclass/qt4-build.eclass
Gentoo

Diff of /eclass/qt4-build.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.68 Revision 1.120
1# Copyright 1999-2009 Gentoo Foundation 1# Copyright 1999-2012 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/qt4-build.eclass,v 1.68 2010/05/22 19:23:51 wired Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/qt4-build.eclass,v 1.120 2012/02/28 18:53:45 pesa Exp $
4 4
5# @ECLASS: qt4-build.eclass 5# @ECLASS: qt4-build.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# Ben de Groot <yngwin@gentoo.org>, 7# Qt herd <qt@gentoo.org>
8# Markos Chandras <hwoarang@gentoo.org>,
9# Caleb Tennis <caleb@gentoo.org>
10# Alex Alexander <wired@gentoo.org>
11# @BLURB: Eclass for Qt4 split ebuilds. 8# @BLURB: Eclass for Qt4 split ebuilds.
12# @DESCRIPTION: 9# @DESCRIPTION:
13# This eclass contains various functions that are used when building Qt4 10# This eclass contains various functions that are used when building Qt4.
14 11
15inherit base eutils multilib toolchain-funcs flag-o-matic versionator 12inherit base eutils multilib toolchain-funcs flag-o-matic versionator
16 13
17MY_PV=${PV/_/-} 14MY_PV=${PV/_/-}
18if version_is_at_least 4.5.99999999; then
19 MY_P=qt-everywhere-opensource-src-${MY_PV} 15MY_P=qt-everywhere-opensource-src-${MY_PV}
16
17HOMEPAGE="http://qt.nokia.com/ http://qt-project.org/"
18SRC_URI="http://get.qt.nokia.com/qt/source/${MY_P}.tar.gz"
19LICENSE="|| ( LGPL-2.1 GPL-3 )"
20
21IUSE="aqua debug pch"
22
20 [[ ${CATEGORY}/${PN} != x11-libs/qt-xmlpatterns ]] && IUSE="+exceptions" 23[[ ${CATEGORY}/${PN} != x11-libs/qt-xmlpatterns ]] &&
21else 24[[ ${CATEGORY}/${PN} != x11-themes/qgtkstyle ]] &&
22 MY_P=qt-x11-opensource-src-${MY_PV} 25 IUSE+=" +exceptions"
26
27if version_is_at_least 4.7.99999999; then
28 IUSE+=" c++0x qpa"
23fi 29fi
24 30
25HOMEPAGE="http://qt.nokia.com/" 31DEPEND="dev-util/pkgconfig"
26SRC_URI="http://get.qt.nokia.com/qt/source/${MY_P}.tar.gz"
27
28LICENSE="|| ( LGPL-2.1 GPL-3 )"
29IUSE+=" debug pch aqua"
30
31RDEPEND=" 32RDEPEND="
32 !<x11-libs/qt-assistant-${PV} 33 !<x11-libs/qt-assistant-${PV}
33 !>x11-libs/qt-assistant-${PV}-r9999 34 !>x11-libs/qt-assistant-${PV}-r9999
34 !<x11-libs/qt-core-${PV} 35 !<x11-libs/qt-core-${PV}
35 !>x11-libs/qt-core-${PV}-r9999 36 !>x11-libs/qt-core-${PV}-r9999
36 !<x11-libs/qt-dbus-${PV} 37 !<x11-libs/qt-dbus-${PV}
37 !>x11-libs/qt-dbus-${PV}-r9999 38 !>x11-libs/qt-dbus-${PV}-r9999
39 !<x11-libs/qt-declarative-${PV}
40 !>x11-libs/qt-declarative-${PV}-r9999
38 !<x11-libs/qt-demo-${PV} 41 !<x11-libs/qt-demo-${PV}
39 !>x11-libs/qt-demo-${PV}-r9999 42 !>x11-libs/qt-demo-${PV}-r9999
40 !<x11-libs/qt-gui-${PV} 43 !<x11-libs/qt-gui-${PV}
41 !>x11-libs/qt-gui-${PV}-r9999 44 !>x11-libs/qt-gui-${PV}-r9999
42 !<x11-libs/qt-multimedia-${PV} 45 !<x11-libs/qt-multimedia-${PV}
43 !>x11-libs/qt-multimedia-${PV}-r9999 46 !>x11-libs/qt-multimedia-${PV}-r9999
44 !<x11-libs/qt-opengl-${PV} 47 !<x11-libs/qt-opengl-${PV}
45 !>x11-libs/qt-opengl-${PV}-r9999 48 !>x11-libs/qt-opengl-${PV}-r9999
49 !<x11-libs/qt-openvg-${PV}
50 !>x11-libs/qt-openvg-${PV}-r9999
46 !<x11-libs/qt-phonon-${PV} 51 !<x11-libs/qt-phonon-${PV}
47 !>x11-libs/qt-phonon-${PV}-r9999 52 !>x11-libs/qt-phonon-${PV}-r9999
48 !<x11-libs/qt-qt3support-${PV} 53 !<x11-libs/qt-qt3support-${PV}
49 !>x11-libs/qt-qt3support-${PV}-r9999 54 !>x11-libs/qt-qt3support-${PV}-r9999
50 !<x11-libs/qt-script-${PV} 55 !<x11-libs/qt-script-${PV}
63 68
64S=${WORKDIR}/${MY_P} 69S=${WORKDIR}/${MY_P}
65 70
66# @FUNCTION: qt4-build_pkg_setup 71# @FUNCTION: qt4-build_pkg_setup
67# @DESCRIPTION: 72# @DESCRIPTION:
68# Sets up S, MY_P, PATH, and LD_LIBRARY_PATH 73# Sets up PATH and LD_LIBRARY_PATH.
69qt4-build_pkg_setup() { 74qt4-build_pkg_setup() {
70 if [[ "${PN}" == "qt-webkit" ]]; then
71 if [[ "${CFLAGS}" =~ "-ggdb" ]] || [[ "${CXXFLAGS}" =~ "-ggdb" ]]; then
72 echo
73 ewarn "Your \$C{,XX}FLAGS contain -ggdb. You may experience really"
74 ewarn "long compilation times and/or increased memory usage."
75 ewarn "If compilation fails, please try removing -ggdb before"
76 ewarn "reporting a bug."
77 ewarn "For more info check out bug #307861"
78 echo
79 fi
80 fi
81
82 [[ ${EAPI} == 2 ]] && use !prefix && EPREFIX= 75 [[ ${EAPI} == 2 ]] && use !prefix && EPREFIX=
83 76
84 # Protect users by not allowing downgrades between releases 77 # Protect users by not allowing downgrades between releases
85 # Downgrading revisions within the same release should be allowed 78 # Downgrading revisions within the same release should be allowed
86 if has_version '>'${CATEGORY}/${P}-r9999 ; then 79 if has_version '>'${CATEGORY}/${P}-r9999; then
87 if [[ -z $I_KNOW_WHAT_I_AM_DOING ]] ; then 80 if [[ -z ${I_KNOW_WHAT_I_AM_DOING} ]]; then
88 eerror "Sanity check to keep you from breaking your system:" 81 eerror "Sanity check to keep you from breaking your system:"
89 eerror " Downgrading Qt is completely unsupported and will break your system!" 82 eerror " Downgrading Qt is completely unsupported and will break your system!"
90 die "aborting to save your system" 83 die "aborting to save your system"
91 else 84 else
92 ewarn "Downgrading Qt is completely unsupported and will break your system!" 85 ewarn "Downgrading Qt is completely unsupported and will break your system!"
93 fi 86 fi
87 fi
88
89 if [[ ${PN} == "qt-webkit" ]]; then
90 eshopts_push -s extglob
91 if is-flagq '-g?(gdb)?([1-9])'; then
92 echo
93 ewarn "You have enabled debug info (probably have -g or -ggdb in your \$C{,XX}FLAGS)."
94 ewarn "You may experience really long compilation times and/or increased memory usage."
95 ewarn "If compilation fails, please try removing -g{,gdb} before reporting a bug."
96 ewarn "For more info check out bug #307861"
97 echo
98 fi
99 eshopts_pop
94 fi 100 fi
95 101
96 PATH="${S}/bin${PATH:+:}${PATH}" 102 PATH="${S}/bin${PATH:+:}${PATH}"
97 if [[ ${CHOST} != *-darwin* ]]; then 103 if [[ ${CHOST} != *-darwin* ]]; then
98 LD_LIBRARY_PATH="${S}/lib${LD_LIBRARY_PATH:+:}${LD_LIBRARY_PATH}" 104 LD_LIBRARY_PATH="${S}/lib${LD_LIBRARY_PATH:+:}${LD_LIBRARY_PATH}"
105 QT4_EXTRACT_DIRECTORIES="src/gui/kernel/qapplication_mac.mm 111 QT4_EXTRACT_DIRECTORIES="src/gui/kernel/qapplication_mac.mm
106 ${QT4_EXTRACT_DIRECTORIES}" 112 ${QT4_EXTRACT_DIRECTORIES}"
107 fi 113 fi
108 114
109 # Make sure ebuilds use the required EAPI 115 # Make sure ebuilds use the required EAPI
110 if [[ ${EAPI} != [23] ]]; then 116 if [[ ${EAPI} != [234] ]]; then
111 eerror "The qt4-build eclass requires EAPI=2 or EAPI=3, but this ebuild is using" 117 eerror "The qt4-build eclass requires EAPI 2,3 or 4 but this ebuild is using"
112 eerror "EAPI=${EAPI:-0}. The ebuild author or editor failed. This ebuild needs to be" 118 eerror "EAPI=${EAPI:-0}. The ebuild author or editor failed. This ebuild needs to be"
113 eerror "fixed. Using qt4-build eclass without EAPI=2 or EAPI=3 will fail." 119 eerror "fixed. Using qt4-build eclass without EAPI 2,3 or 4 will fail."
114 die "qt4-build eclass requires EAPI=2 or EAPI=3" 120 die "qt4-build eclass requires EAPI 2,3 or 4"
115 fi 121 fi
116 122
117 if ! version_is_at_least 4.1 $(gcc-version); then 123 if ! version_is_at_least 4.1 $(gcc-version); then
118 ewarn "Using a GCC version lower than 4.1 is not supported!" 124 ewarn "Using a GCC version lower than 4.1 is not supported!"
119 fi 125 fi
120} 126}
121 127
122# @ECLASS-VARIABLE: QT4_TARGET_DIRECTORIES 128# @ECLASS-VARIABLE: QT4_TARGET_DIRECTORIES
123# @DESCRIPTION: 129# @DESCRIPTION:
124# Arguments for build_target_directories. Takes the directories, in which the 130# Arguments for build_target_directories. Takes the directories in which the
125# code should be compiled. This is a space-separated list 131# code should be compiled. This is a space-separated list.
126 132
127# @ECLASS-VARIABLE: QT4_EXTRACT_DIRECTORIES 133# @ECLASS-VARIABLE: QT4_EXTRACT_DIRECTORIES
128# @DESCRIPTION: 134# @DESCRIPTION:
129# Space separated list including the directories that will be extracted from Qt 135# Space-separated list including the directories that will be extracted from
130# tarball 136# Qt tarball.
131 137
132# @FUNCTION: qt4-build_src_unpack 138# @FUNCTION: qt4-build_src_unpack
133# @DESCRIPTION: 139# @DESCRIPTION:
134# Unpacks the sources 140# Unpacks the sources.
135qt4-build_src_unpack() { 141qt4-build_src_unpack() {
136 setqtenv 142 setqtenv
137 local target targets= 143
144 local tarball="${MY_P}.tar.gz" target= targets=
138 for target in configure LICENSE.GPL3 LICENSE.LGPL projects.pro \ 145 for target in configure LICENSE.GPL3 LICENSE.LGPL projects.pro \
139 src/{qbase,qt_targets,qt_install}.pri bin config.tests mkspecs qmake \ 146 src/{qbase,qt_targets,qt_install}.pri bin config.tests \
140 ${QT4_EXTRACT_DIRECTORIES}; do 147 mkspecs qmake ${QT4_EXTRACT_DIRECTORIES}
148 do
141 targets+=" ${MY_P}/${target}" 149 targets+="${MY_P}/${target} "
142 done 150 done
143 151
152 ebegin "Unpacking parts of ${tarball}:" ${targets//${MY_P}\/}
144 echo tar xzpf "${DISTDIR}"/${MY_P}.tar.gz ${targets} 153 tar -xzf "${DISTDIR}/${tarball}" ${targets}
145 tar xzpf "${DISTDIR}"/${MY_P}.tar.gz ${targets} || die 154 eend $? || die "failed to unpack"
146} 155}
147 156
148# @ECLASS-VARIABLE: PATCHES 157# @ECLASS-VARIABLE: PATCHES
158# @DEFAULT_UNSET
149# @DESCRIPTION: 159# @DESCRIPTION:
150# In case you have patches to apply, specify them in PATCHES variable. Make sure 160# PATCHES array variable containing all various patches to be applied.
151# to specify the full path. This variable is necessary for src_prepare phase. 161# This variable is expected to be defined in global scope of ebuild.
152# example: 162# Make sure to specify the full path. This variable is utilised in
153# PATCHES="${FILESDIR}"/mypatch.patch 163# src_unpack/src_prepare phase, based on EAPI.
154# ${FILESDIR}"/mypatch2.patch"
155# 164#
165# @CODE
166# PATCHES=( "${FILESDIR}/mypatch.patch"
167# "${FILESDIR}/patches_folder/" )
168# @CODE
156 169
157# @FUNCTION: qt4-build_src_prepare 170# @FUNCTION: qt4-build_src_prepare
158# @DESCRIPTION: 171# @DESCRIPTION:
159# Prepare the sources before the configure phase. Strip CFLAGS if necessary, and fix 172# Prepare the sources before the configure phase. Strip CFLAGS if necessary, and fix
160# source files in order to respect CFLAGS/CXXFLAGS/LDFLAGS specified on /etc/make.conf. 173# the build system in order to respect CFLAGS/CXXFLAGS/LDFLAGS specified in /etc/make.conf.
161qt4-build_src_prepare() { 174qt4-build_src_prepare() {
162 setqtenv 175 setqtenv
163 cd "${S}" 176 cd "${S}"
164 177
178 if version_is_at_least "4.7"; then
179 # fix libX11 dependency on non X packages
180 local nolibx11_pkgs="qt-core qt-dbus qt-script qt-sql qt-test qt-xmlpatterns"
181 has ${PN} ${nolibx11_pkgs} && qt_nolibx11
182
183 qt_assistant_cleanup
184 fi
185
165 if use aqua; then 186 if use aqua; then
166 # provide a proper macx-g++-64 187 # provide a proper macx-g++-64
167 use x64-macos && ln -s macx-g++ mkspecs/$(qt_mkspecs_dir) 188 use x64-macos && ln -s macx-g++ mkspecs/$(qt_mkspecs_dir)
168 189
169 sed -e '/^CONFIG/s:app_bundle::' \ 190 sed -e '/^CONFIG/s:app_bundle::' \
170 -e '/^CONFIG/s:plugin_no_soname:plugin_with_soname absolute_library_soname:' \ 191 -e '/^CONFIG/s:plugin_no_soname:plugin_with_soname absolute_library_soname:' \
171 -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die "sed failed" 192 -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
172 fi 193 fi
173 194
174 if [[ ${PN} != qt-core ]]; then 195 if [[ ${PN} != qt-core ]]; then
175 skip_qmake_build_patch 196 skip_qmake_build
176 skip_project_generation_patch 197 skip_project_generation
177 symlink_binaries_to_buildtree 198 symlink_binaries_to_buildtree
178 fi 199 fi
179 200
180 if [[ ${CHOST} == *86*-apple-darwin* ]] ; then 201 if [[ ${CHOST} == *86*-apple-darwin* ]]; then
181 # qmake bus errors with -O2 but -O3 works 202 # qmake bus errors with -O2 but -O3 works
182 replace-flags -O2 -O3 203 replace-flags -O2 -O3
183 fi 204 fi
184 205
185 # Bug 178652 206 # Bug 178652
186 if [[ $(gcc-major-version) == 3 ]] && use amd64; then 207 if [[ $(gcc-major-version) == 3 ]] && use amd64; then
187 ewarn "Appending -fno-gcse to CFLAGS/CXXFLAGS" 208 ewarn "Appending -fno-gcse to CFLAGS/CXXFLAGS"
188 append-flags -fno-gcse 209 append-flags -fno-gcse
189 fi 210 fi
190 211
212 if use_if_iuse c++0x; then
213 ewarn "You are about to build Qt4 using the C++11 standard. Even though"
214 ewarn "this is an official standard, some of the reverse dependencies"
215 ewarn "may fail to compile or link againt the Qt4 libraries. Before"
216 ewarn "reporting a bug, make sure your bug is reproducible with c++0x"
217 ewarn "disabled."
218 append-flags -std=c++0x
219 fi
220
191 # Unsupported old gcc versions - hardened needs this :( 221 # Unsupported old gcc versions - hardened needs this :(
192 if [[ $(gcc-major-version) -lt 4 ]] ; then 222 if [[ $(gcc-major-version) -lt 4 ]]; then
193 ewarn "Appending -fno-stack-protector to CXXFLAGS" 223 ewarn "Appending -fno-stack-protector to CXXFLAGS"
194 append-cxxflags -fno-stack-protector 224 append-cxxflags -fno-stack-protector
195 # Bug 253127 225 # Bug 253127
196 sed -e "/^QMAKE_CFLAGS\t/ s:$: -fno-stack-protector-all:" \ 226 sed -e "/^QMAKE_CFLAGS\t/ s:$: -fno-stack-protector-all:" \
197 -i "${S}"/mkspecs/common/g++.conf || die "sed ${S}/mkspecs/common/g++.conf failed" 227 -i mkspecs/common/g++.conf || die
198 fi 228 fi
199 229
200 # Bug 261632 230 # Bug 261632
201 if use ppc64; then 231 if use ppc64; then
202 ewarn "Appending -mminimal-toc to CFLAGS/CXXFLAGS" 232 ewarn "Appending -mminimal-toc to CFLAGS/CXXFLAGS"
203 append-flags -mminimal-toc 233 append-flags -mminimal-toc
204 fi 234 fi
205 235
206 # Bug 282984 && Bug 295530 236 # Respect CC, CXX, {C,CXX,LD}FLAGS in .qmake.cache
207 sed -e "s:\(^SYSTEM_VARIABLES\):CC=$(tc-getCC)\nCXX=$(tc-getCXX)\nCFLAGS=\"${CFLAGS}\"\nCXXFLAGS=\"${CXXFLAGS}\"\nLDFLAGS=\"${LDFLAGS}\"\n\1:" \ 237 sed -e "/^SYSTEM_VARIABLES=/i \
208 -i configure || die "sed qmake compilers failed" 238 CC='$(tc-getCC)'\n\
209 sed -e "s:\(\$MAKE\):\1 CC=$(tc-getCC) CXX=$(tc-getCXX) LD=$(tc-getCXX) LINK=$(tc-getCXX):" \ 239 CXX='$(tc-getCXX)'\n\
210 -i config.tests/unix/compile.test || die "sed test compilers failed" 240 CFLAGS='${CFLAGS}'\n\
241 CXXFLAGS='${CXXFLAGS}'\n\
242 LDFLAGS='${LDFLAGS}'\n" \
243 -i configure \
244 || die "sed SYSTEM_VARIABLES failed"
245
246 # Respect CC, CXX, LINK and *FLAGS in config.tests
247 find config.tests/unix -name '*.test' -type f -print0 | xargs -0 \
248 sed -i -e "/bin\/qmake/ s: \"QT_BUILD_TREE=: \
249 'QMAKE_CC=$(tc-getCC)' 'QMAKE_CXX=$(tc-getCXX)' 'QMAKE_LINK=$(tc-getCXX)' \
250 'QMAKE_CFLAGS+=${CFLAGS}' 'QMAKE_CXXFLAGS+=${CXXFLAGS}' 'QMAKE_LFLAGS+=${LDFLAGS}'&:" \
251 || die "sed config.tests failed"
252
253 # Strip predefined CFLAGS from mkspecs (bug 312689)
254 sed -i -e '/^QMAKE_CFLAGS_RELEASE/s:+=.*:+=:' mkspecs/common/g++.conf || die
211 255
212 # Bug 172219 256 # Bug 172219
213 sed -e "s:X11R6/::" \ 257 sed -e 's:/X11R6/:/:' -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
214 -i "${S}"/mkspecs/$(qt_mkspecs_dir)/qmake.conf || die "sed ${S}/mkspecs/$(qt_mkspecs_dir)/qmake.conf failed"
215 258
216 if [[ ${CHOST} == *-darwin* ]]; then 259 if [[ ${CHOST} == *-darwin* ]]; then
217 # Set FLAGS *and* remove -arch, since our gcc-apple is multilib 260 # Set FLAGS *and* remove -arch, since our gcc-apple is multilib
218 # crippled (by design) :/ 261 # crippled (by design) :/
262 sed \
219 sed -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \ 263 -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \
220 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \ 264 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \
221 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=-headerpad_max_install_names ${LDFLAGS}:" \ 265 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=-headerpad_max_install_names ${LDFLAGS}:" \
222 -e "s:-arch\s\w*::g" \ 266 -e "s:-arch\s\w*::g" \
223 -i mkspecs/common/mac-g++.conf || die "sed mkspecs/common/mac-g++.conf failed" 267 -i mkspecs/common/mac-g++.conf \
268 || die "sed mkspecs/common/mac-g++.conf failed"
224 269
225 # Fix configure's -arch settings that appear in qmake/Makefile and also 270 # Fix configure's -arch settings that appear in qmake/Makefile and also
226 # fix arch handling (automagically duplicates our -arch arg and breaks 271 # fix arch handling (automagically duplicates our -arch arg and breaks
227 # pch). Additionally disable Xarch support. 272 # pch). Additionally disable Xarch support.
228 sed \ 273 sed \
233 -e "s:-arch \$i::" \ 278 -e "s:-arch \$i::" \
234 -e "/if \[ ! -z \"\$NATIVE_64_ARCH\" \]; then/,/fi/ d" \ 279 -e "/if \[ ! -z \"\$NATIVE_64_ARCH\" \]; then/,/fi/ d" \
235 -e "s:CFG_MAC_XARCH=yes:CFG_MAC_XARCH=no:g" \ 280 -e "s:CFG_MAC_XARCH=yes:CFG_MAC_XARCH=no:g" \
236 -e "s:-Xarch_x86_64::g" \ 281 -e "s:-Xarch_x86_64::g" \
237 -e "s:-Xarch_ppc64::g" \ 282 -e "s:-Xarch_ppc64::g" \
238 -i configure mkspecs/common/mac-g++.conf || die "sed configure failed" 283 -i configure mkspecs/common/mac-g++.conf \
284 || die "sed -arch/-Xarch failed"
239 285
240 # On Snow Leopard don't fall back to 10.5 deployment target. 286 # On Snow Leopard don't fall back to 10.5 deployment target.
241 if [[ ${CHOST} == *-apple-darwin10 ]] ; then 287 if [[ ${CHOST} == *-apple-darwin10 ]]; then
242 sed -e "s:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET.*:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET 10.6:g" \ 288 sed -e "s:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET.*:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET 10.6:g" \
243 -e "s:-mmacosx-version-min=10.[0-9]:-mmacosx-version-min=10.6:g" \ 289 -e "s:-mmacosx-version-min=10.[0-9]:-mmacosx-version-min=10.6:g" \
244 -i configure mkspecs/common/mac-g++.conf || die "sed configure failed" 290 -i configure mkspecs/common/mac-g++.conf \
291 || die "sed deployment target failed"
245 fi 292 fi
246 fi 293 fi
247 294
248 # this one is needed for all systems with a separate -liconv, apart from 295 # this one is needed for all systems with a separate -liconv, apart from
249 # Darwin, for which the sources already cater for -liconv 296 # Darwin, for which the sources already cater for -liconv
250 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]] ; then 297 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]]; then
251 sed \ 298 sed -e 's|mac:\(LIBS += -liconv\)|\1|g' \
252 -e "s|mac:LIBS += -liconv|LIBS += -liconv|g" \
253 -i config.tests/unix/iconv/iconv.pro \ 299 -i config.tests/unix/iconv/iconv.pro \
254 || die "sed on iconv.pro failed" 300 || die "sed iconv.pro failed"
255 fi 301 fi
256 302
257 # we need some patches for Solaris 303 # we need some patches for Solaris
258 sed -i \
259 -e '/^QMAKE_LFLAGS_THREAD/a\QMAKE_LFLAGS_DYNAMIC_LIST = -Wl,--dynamic-list,' \ 304 sed -i -e '/^QMAKE_LFLAGS_THREAD/a\QMAKE_LFLAGS_DYNAMIC_LIST = -Wl,--dynamic-list,' \
260 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die 305 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
261 # use GCC over SunStudio 306 # use GCC over SunStudio
262 sed -i -e '/PLATFORM=solaris-cc/s/cc/g++/' configure || die 307 sed -i -e '/PLATFORM=solaris-cc/s/cc/g++/' configure || die
263 # don't flirt with non-Prefix stuff, we're quite possessive 308 # do not flirt with non-Prefix stuff, we're quite possessive
264 sed -i -e '/^QMAKE_\(LIB\|INC\)DIR\(_X11\|_OPENGL\|\)\t/s/=.*$/=/' \ 309 sed -i -e '/^QMAKE_\(LIB\|INC\)DIR\(_X11\|_OPENGL\|\)\t/s/=.*$/=/' \
265 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die 310 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
266 311
267 base_src_prepare 312 base_src_prepare
268} 313}
274 setqtenv 319 setqtenv
275 myconf="$(standard_configure_options) ${myconf}" 320 myconf="$(standard_configure_options) ${myconf}"
276 321
277 # this one is needed for all systems with a separate -liconv, apart from 322 # this one is needed for all systems with a separate -liconv, apart from
278 # Darwin, for which the sources already cater for -liconv 323 # Darwin, for which the sources already cater for -liconv
279 use !elibc_glibc && [[ ${CHOST} != *-darwin* ]] && \ 324 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]]; then
280 myconf+=" -liconv" 325 myconf+=" -liconv"
326 fi
281 327
282 if has glib ${IUSE//+} && use glib; then 328 if use_if_iuse glib; then
283 # use -I, -L and -l from configure
284 local glibflags="$(pkg-config --cflags --libs glib-2.0 gthread-2.0)" 329 local glibflags="$(pkg-config --cflags --libs glib-2.0 gthread-2.0)"
285 # avoid the -pthread argument 330 # avoid the -pthread argument
286 myconf+=" ${glibflags//-pthread}" 331 myconf+=" ${glibflags//-pthread}"
287 unset glibflags 332 unset glibflags
288 fi 333 fi
289 334
335 if use_if_iuse qpa; then
336 ewarn
337 ewarn "The qpa useflag enables the Qt Platform Abstraction, formely"
338 ewarn "known as Qt Lighthouse. If you are not sure what that is, then"
339 ewarn "disable it before reporting any bugs related to this useflag."
340 ewarn
341 myconf+=" -qpa"
342 fi
343
290 if use aqua ; then 344 if use aqua; then
291 # On (snow) leopard use the new (frameworked) cocoa code. 345 # On (snow) leopard use the new (frameworked) cocoa code.
292 if [[ ${CHOST##*-darwin} -ge 9 ]] ; then 346 if [[ ${CHOST##*-darwin} -ge 9 ]]; then
293 myconf+=" -cocoa -framework" 347 myconf+=" -cocoa -framework"
348 # We need the source's headers, not the installed ones.
349 myconf+=" -I${S}/include"
350 # Add hint for the framework location.
351 myconf+=" -F${QTLIBDIR}"
294 352
295 # We are crazy and build cocoa + qt3support :-) 353 # We are crazy and build cocoa + qt3support :-)
296 if use qt3support; then 354 if use qt3support; then
297 sed -e "/case \"\$PLATFORM,\$CFG_MAC_COCOA\" in/,/;;/ s|CFG_QT3SUPPORT=\"no\"|CFG_QT3SUPPORT=\"yes\"|" \ 355 sed -e "/case \"\$PLATFORM,\$CFG_MAC_COCOA\" in/,/;;/ s|CFG_QT3SUPPORT=\"no\"|CFG_QT3SUPPORT=\"yes\"|" \
298 -i configure 356 -i configure || die
299 fi 357 fi
300 358 else
301 # We need the source's headers, not the installed ones. 359 myconf+=" -no-framework"
302 myconf+=" -I${S}/include"
303
304 # Add hint for the framework location.
305 myconf+=" -F${QTLIBDIR}"
306 fi 360 fi
307 else 361 else
308 # freetype2 include dir is non-standard, thus include it on configure 362 # freetype2 include dir is non-standard, thus include it on configure
309 # use -I from configure 363 # use -I from configure
310 myconf+=" $(pkg-config --cflags freetype2)" 364 myconf+=" $(pkg-config --cflags freetype2)"
311 fi 365 fi
312 366
313 echo ./configure ${myconf} 367 echo ./configure ${myconf}
314 ./configure ${myconf} || die "./configure failed" 368 ./configure ${myconf} || die "./configure failed"
315 myconf="" 369 myconf=""
370
371 prepare_directories ${QT4_TARGET_DIRECTORIES}
316} 372}
317 373
318# @FUNCTION: qt4-build_src_compile 374# @FUNCTION: qt4-build_src_compile
375# @DESCRIPTION:
319# @DESCRIPTION: Actual compile phase 376# Actual compile phase
320qt4-build_src_compile() { 377qt4-build_src_compile() {
321 setqtenv 378 setqtenv
322 379
323 build_directories ${QT4_TARGET_DIRECTORIES} 380 build_directories ${QT4_TARGET_DIRECTORIES}
324} 381}
325 382
383# @FUNCTION: qt4-build_src_test
384# @DESCRIPTION:
385# Runs tests only in target directories.
386qt4-build_src_test() {
387 # QtMultimedia does not have any test suite (bug #332299)
388 [[ ${PN} == "qt-multimedia" ]] && return
389
390 for dir in ${QT4_TARGET_DIRECTORIES}; do
391 emake -j1 check -C ${dir}
392 done
393}
394
326# @FUNCTION: fix_includes 395# @FUNCTION: fix_includes
327# @DESCRIPTION: 396# @DESCRIPTION:
328# For MacOSX we need to add some symlinks when frameworks are 397# For MacOS X we need to add some symlinks when frameworks are
329# being used, to avoid complications with some more or less stupid packages. 398# being used, to avoid complications with some more or less stupid packages.
330fix_includes() { 399fix_includes() {
331 if use aqua && [[ ${CHOST##*-darwin} -ge 9 ]] ; then 400 if use aqua && [[ ${CHOST##*-darwin} -ge 9 ]]; then
332 # Some packages tend to include <Qt/...> 401 # Some packages tend to include <Qt/...>
333 dodir "${QTHEADERDIR#${EPREFIX}}"/Qt 402 dodir "${QTHEADERDIR#${EPREFIX}}"/Qt
334 403
335 # Fake normal headers when frameworks are installed... eases life later on 404 # Fake normal headers when frameworks are installed... eases life later on
336 local dest f 405 local dest f h
337 for frw in "${D}${QTLIBDIR}"/*.framework; do 406 for frw in "${D}${QTLIBDIR}"/*.framework; do
338 [[ -e "${frw}"/Headers ]] || continue 407 [[ -e "${frw}"/Headers ]] || continue
339 f=$(basename ${frw}) 408 f=$(basename ${frw})
340 dest="${QTHEADERDIR#${EPREFIX}}"/${f%.framework} 409 dest="${QTHEADERDIR#${EPREFIX}}"/${f%.framework}
341 dosym "${QTLIBDIR#${EPREFIX}}"/${f}/Headers "${dest}" 410 dosym "${QTLIBDIR#${EPREFIX}}"/${f}/Headers "${dest}"
353# @DESCRIPTION: 422# @DESCRIPTION:
354# Perform the actual installation including some library fixes. 423# Perform the actual installation including some library fixes.
355qt4-build_src_install() { 424qt4-build_src_install() {
356 [[ ${EAPI} == 2 ]] && use !prefix && ED=${D} 425 [[ ${EAPI} == 2 ]] && use !prefix && ED=${D}
357 setqtenv 426 setqtenv
427
358 install_directories ${QT4_TARGET_DIRECTORIES} 428 install_directories ${QT4_TARGET_DIRECTORIES}
359 install_qconfigs 429 install_qconfigs
360 fix_library_files 430 fix_library_files
361 fix_includes 431 fix_includes
432
433 # remove .la files since we are building only shared Qt libraries
434 find "${D}"${QTLIBDIR} -type f -name '*.la' -print0 | xargs -0 rm -f
362} 435}
363 436
364# @FUNCTION: setqtenv 437# @FUNCTION: setqtenv
438# @INTERNAL
365setqtenv() { 439setqtenv() {
366 # Set up installation directories 440 # Set up installation directories
367 QTBASEDIR=${EPREFIX}/usr/$(get_libdir)/qt4
368 QTPREFIXDIR=${EPREFIX}/usr 441 QTPREFIXDIR=${EPREFIX}/usr
369 QTBINDIR=${EPREFIX}/usr/bin 442 QTBINDIR=${EPREFIX}/usr/bin
370 QTLIBDIR=${EPREFIX}/usr/$(get_libdir)/qt4 443 QTLIBDIR=${EPREFIX}/usr/$(get_libdir)/qt4
371 QMAKE_LIBDIR_QT=${QTLIBDIR}
372 QTPCDIR=${EPREFIX}/usr/$(get_libdir)/pkgconfig 444 QTPCDIR=${EPREFIX}/usr/$(get_libdir)/pkgconfig
373 QTDATADIR=${EPREFIX}/usr/share/qt4
374 QTDOCDIR=${EPREFIX}/usr/share/doc/qt-${PV} 445 QTDOCDIR=${EPREFIX}/usr/share/doc/qt-${PV}
375 QTHEADERDIR=${EPREFIX}/usr/include/qt4 446 QTHEADERDIR=${EPREFIX}/usr/include/qt4
376 QTPLUGINDIR=${QTLIBDIR}/plugins 447 QTPLUGINDIR=${QTLIBDIR}/plugins
448 QTIMPORTDIR=${QTLIBDIR}/imports
449 QTDATADIR=${EPREFIX}/usr/share/qt4
450 QTTRANSDIR=${QTDATADIR}/translations
377 QTSYSCONFDIR=${EPREFIX}/etc/qt4 451 QTSYSCONFDIR=${EPREFIX}/etc/qt4
378 QTTRANSDIR=${QTDATADIR}/translations
379 QTEXAMPLESDIR=${QTDATADIR}/examples 452 QTEXAMPLESDIR=${QTDATADIR}/examples
380 QTDEMOSDIR=${QTDATADIR}/demos 453 QTDEMOSDIR=${QTDATADIR}/demos
454 QMAKE_LIBDIR_QT=${QTLIBDIR}
381 QT_INSTALL_PREFIX=${EPREFIX}/usr/$(get_libdir)/qt4 455 QT_INSTALL_PREFIX=${EPREFIX}/usr/$(get_libdir)/qt4
456
382 PLATFORM=$(qt_mkspecs_dir) 457 PLATFORM=$(qt_mkspecs_dir)
383 458
384 unset QMAKESPEC 459 unset QMAKESPEC
385} 460}
386 461
387# @FUNCTION: standard_configure_options 462# @FUNCTION: standard_configure_options
463# @INTERNAL
388# @DESCRIPTION: 464# @DESCRIPTION:
389# Sets up some standard configure options, like libdir (if necessary), whether 465# Sets up some standard configure options, like libdir (if necessary), whether
390# debug info is wanted or not. 466# debug info is wanted or not.
391standard_configure_options() { 467standard_configure_options() {
392 local myconf= 468 local myconf="
469 -prefix ${QTPREFIXDIR} -bindir ${QTBINDIR} -libdir ${QTLIBDIR}
470 -docdir ${QTDOCDIR} -headerdir ${QTHEADERDIR} -plugindir ${QTPLUGINDIR}
471 $(version_is_at_least 4.7 && echo -importdir ${QTIMPORTDIR})
472 -datadir ${QTDATADIR} -translationdir ${QTTRANSDIR} -sysconfdir ${QTSYSCONFDIR}
473 -examplesdir ${QTEXAMPLESDIR} -demosdir ${QTDEMOSDIR}
474 -opensource -confirm-license -shared -fast -largefile -stl -verbose
475 -platform $(qt_mkspecs_dir) -nomake examples -nomake demos"
393 476
394 [[ $(get_libdir) != lib ]] && myconf+=" -L${EPREFIX}/usr/$(get_libdir)" 477 [[ $(get_libdir) != lib ]] && myconf+=" -L${EPREFIX}/usr/$(get_libdir)"
395 478
396 # Disable visibility explicitly if gcc version isn't 4 479 # debug/release
397 if [[ $(gcc-major-version) -lt 4 ]]; then
398 myconf+=" -no-reduce-exports"
399 fi
400
401 # precompiled headers doesn't work on hardened, where the flag is masked.
402 myconf+=" $(qt_use pch)"
403
404 if use debug; then 480 if use debug; then
405 myconf+=" -debug" 481 myconf+=" -debug"
406 else 482 else
407 myconf+=" -release" 483 myconf+=" -release"
408 fi 484 fi
409 myconf+=" -no-separate-debug-info" 485 myconf+=" -no-separate-debug-info"
410 486
411 use aqua && myconf+=" -no-framework" 487 # exceptions USE flag
488 myconf+=" $(in_iuse exceptions && qt_use exceptions || echo -exceptions)"
489
490 # disable RPATH on Qt >= 4.8 (bug 380415)
491 version_is_at_least 4.8 && myconf+=" -no-rpath"
492
493 # precompiled headers don't work on hardened, where the flag is masked
494 myconf+=" $(qt_use pch)"
495
496 # -reduce-relocations
497 # This flag seems to introduce major breakage to applications,
498 # mostly to be seen as a core dump with the message "QPixmap: Must
499 # construct a QApplication before a QPaintDevice" on Solaris.
500 # -- Daniel Vergien
501 [[ ${CHOST} != *-solaris* ]] && myconf+=" -reduce-relocations"
412 502
413 # ARCH is set on Gentoo. Qt now falls back to generic on an unsupported 503 # ARCH is set on Gentoo. Qt now falls back to generic on an unsupported
414 # $(tc-arch). Therefore we convert it to supported values. 504 # $(tc-arch). Therefore we convert it to supported values.
415 case "$(tc-arch)" in 505 case "$(tc-arch)" in
416 amd64|x64-*) myconf+=" -arch x86_64" ;; 506 amd64|x64-*) myconf+=" -arch x86_64" ;;
417 ppc-macos) myconf+=" -arch ppc" ;; 507 ppc-macos) myconf+=" -arch ppc" ;;
418 ppc|ppc64|ppc-*) myconf+=" -arch powerpc" ;; 508 ppc|ppc64|ppc-*) myconf+=" -arch powerpc" ;;
419 sparc|sparc-*) myconf+=" -arch sparc" ;; 509 sparc|sparc-*|sparc64-*) myconf+=" -arch sparc" ;;
420 x86-macos) myconf+=" -arch x86" ;; 510 x86-macos) myconf+=" -arch x86" ;;
421 x86|x86-*) myconf+=" -arch i386" ;; 511 x86|x86-*) myconf+=" -arch i386" ;;
422 alpha|arm|ia64|mips|s390|sparc) myconf+=" -arch $(tc-arch)" ;; 512 alpha|arm|ia64|mips|s390) myconf+=" -arch $(tc-arch)" ;;
423 hppa|sh) myconf+=" -arch generic" ;; 513 hppa|sh) myconf+=" -arch generic" ;;
424 *) die "$(tc-arch) is unsupported by this eclass. Please file a bug." ;; 514 *) die "$(tc-arch) is unsupported by this eclass. Please file a bug." ;;
425 esac 515 esac
426 516
427 # 4.5: build everything but qt-xmlpatterns w/o exceptions
428 # 4.6: exceptions USE flag
429 local exceptions="-exceptions"
430 case "${PV}" in
431 4.5.*)
432 [[ ${PN} == "qt-xmlpatterns" ]] || exceptions="-no-exceptions"
433 ;;
434 *)
435 has exceptions "${IUSE//+}" && exceptions="$(qt_use exceptions)"
436 ;;
437 esac
438
439 # note about -reduce-relocations:
440 # That flag seems to introduce major breakage to applications,
441 # mostly to be seen as a core dump with the message "QPixmap: Must
442 # construct a QApplication before a QPaintDevice" on Solaris
443 # -- Daniel Vergien
444 [[ ${CHOST} != *-solaris* ]] && myconf+=" -reduce-relocations"
445
446 myconf+=" -platform $(qt_mkspecs_dir) -stl -verbose -largefile -confirm-license
447 -prefix ${QTPREFIXDIR} -bindir ${QTBINDIR} -libdir ${QTLIBDIR}
448 -datadir ${QTDATADIR} -docdir ${QTDOCDIR} -headerdir ${QTHEADERDIR}
449 -plugindir ${QTPLUGINDIR} -sysconfdir ${QTSYSCONFDIR}
450 -translationdir ${QTTRANSDIR} -examplesdir ${QTEXAMPLESDIR}
451 -demosdir ${QTDEMOSDIR} -silent -fast -opensource
452 ${exceptions}
453 -nomake examples -nomake demos"
454
455 echo "${myconf}" 517 echo "${myconf}"
456} 518}
457 519
458# @FUNCTION: build_directories 520# @FUNCTION: prepare_directories
459# @USAGE: < directories > 521# @USAGE: < directories >
522# @INTERNAL
460# @DESCRIPTION: 523# @DESCRIPTION:
461# Compiles the code in $QT4_TARGET_DIRECTORIES 524# Generates Makefiles for the given list of directories.
462build_directories() { 525prepare_directories() {
463 for x in "$@"; do 526 for x in "$@"; do
464 pushd "${S}"/${x} >/dev/null 527 pushd "${S}"/${x} >/dev/null || die
528 einfo "Running qmake in: ${x}"
465 # avoid running over the maximum argument number, bug #299810 529 # avoid running over the maximum argument number, bug #299810
466 { 530 {
467 echo "${S}"/mkspecs/common/*.conf 531 echo "${S}"/mkspecs/common/*.conf
468 find "${S}" -name '*.pr[io]' 532 find "${S}" -name '*.pr[io]'
469 } | xargs sed -i -e "s:\$\$\[QT_INSTALL_LIBS\]:${EPREFIX}/usr/$(get_libdir)/qt4:g" || die 533 } | xargs sed -i \
534 -e "s:\$\$\[QT_INSTALL_LIBS\]:${QTLIBDIR}:g" \
535 -e "s:\$\$\[QT_INSTALL_PLUGINS\]:${QTPLUGINDIR}:g" \
536 || die
470 "${S}"/bin/qmake "LIBS+=-L${QTLIBDIR}" "CONFIG+=nostrip" || die "qmake failed" 537 "${S}"/bin/qmake "LIBS+=-L${QTLIBDIR}" "CONFIG+=nostrip" || die "qmake failed"
538 popd >/dev/null || die
539 done
540}
541
542
543# @FUNCTION: build_directories
544# @USAGE: < directories >
545# @INTERNAL
546# @DESCRIPTION:
547# Compiles the code in the given list of directories.
548build_directories() {
549 for x in "$@"; do
550 pushd "${S}"/${x} >/dev/null || die
471 emake CC="$(tc-getCC)" \ 551 emake CC="$(tc-getCC)" \
472 CXX="$(tc-getCXX)" \ 552 CXX="$(tc-getCXX)" \
473 LINK="$(tc-getCXX)" || die "emake failed" 553 LINK="$(tc-getCXX)" || die "emake failed"
474 popd >/dev/null 554 popd >/dev/null || die
475 done 555 done
476} 556}
477 557
478# @FUNCTION: install_directories 558# @FUNCTION: install_directories
479# @USAGE: < directories > 559# @USAGE: < directories >
560# @INTERNAL
480# @DESCRIPTION: 561# @DESCRIPTION:
481# run emake install in the given directories, which are separated by spaces 562# Runs emake install in the given directories, which are separated by spaces.
482install_directories() { 563install_directories() {
483 for x in "$@"; do 564 for x in "$@"; do
484 pushd "${S}"/${x} >/dev/null || die "Can't pushd ${S}/${x}" 565 pushd "${S}"/${x} >/dev/null || die
485 emake INSTALL_ROOT="${D}" install || die "emake install failed" 566 emake INSTALL_ROOT="${D}" install || die "emake install failed"
486 popd >/dev/null || die "Can't popd from ${S}/${x}" 567 popd >/dev/null || die
487 done 568 done
488} 569}
489 570
490# @ECLASS-VARIABLE: QCONFIG_ADD 571# @ECLASS-VARIABLE: QCONFIG_ADD
491# @DESCRIPTION: 572# @DESCRIPTION:
501# @DESCRIPTION: 582# @DESCRIPTION:
502# List variables that should be defined at the top of QtCore/qconfig.h 583# List variables that should be defined at the top of QtCore/qconfig.h
503: ${QCONFIG_DEFINE:=} 584: ${QCONFIG_DEFINE:=}
504 585
505# @FUNCTION: install_qconfigs 586# @FUNCTION: install_qconfigs
587# @INTERNAL
588# @DESCRIPTION:
506# @DESCRIPTION: Install gentoo-specific mkspecs configurations 589# Install gentoo-specific mkspecs configurations.
507install_qconfigs() { 590install_qconfigs() {
508 local x 591 local x
509 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} ]]; then 592 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} ]]; then
510 for x in QCONFIG_ADD QCONFIG_REMOVE; do 593 for x in QCONFIG_ADD QCONFIG_REMOVE; do
511 [[ -n ${!x} ]] && echo ${x}=${!x} >> "${T}"/${PN}-qconfig.pri 594 [[ -n ${!x} ]] && echo ${x}=${!x} >> "${T}"/${PN}-qconfig.pri
522 doins "${T}"/gentoo-${PN}-qconfig.h || die "installing ${PN}-qconfig.h failed" 605 doins "${T}"/gentoo-${PN}-qconfig.h || die "installing ${PN}-qconfig.h failed"
523 fi 606 fi
524} 607}
525 608
526# @FUNCTION: generate_qconfigs 609# @FUNCTION: generate_qconfigs
527# @DESCRIPTION: Generates gentoo-specific configurations 610# @INTERNAL
611# @DESCRIPTION:
612# Generates gentoo-specific qconfig.{h,pri}.
528generate_qconfigs() { 613generate_qconfigs() {
529 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} || -n ${QCONFIG_DEFINE} || ${CATEGORY}/${PN} == x11-libs/qt-core ]]; then 614 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} || -n ${QCONFIG_DEFINE} || ${CATEGORY}/${PN} == x11-libs/qt-core ]]; then
530 local x qconfig_add qconfig_remove qconfig_new 615 local x qconfig_add qconfig_remove qconfig_new
531 for x in "${ROOT}${QTDATADIR}"/mkspecs/gentoo/*-qconfig.pri; do 616 for x in "${ROOT}${QTDATADIR}"/mkspecs/gentoo/*-qconfig.pri; do
532 [[ -f ${x} ]] || continue 617 [[ -f ${x} ]] || continue
546 631
547 # generate list of QT_CONFIG entries from the existing list 632 # generate list of QT_CONFIG entries from the existing list
548 # including qconfig_add and excluding qconfig_remove 633 # including qconfig_add and excluding qconfig_remove
549 for x in $(sed -n 's/^QT_CONFIG +=//p' \ 634 for x in $(sed -n 's/^QT_CONFIG +=//p' \
550 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri) ${qconfig_add}; do 635 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri) ${qconfig_add}; do
551 hasq ${x} ${qconfig_remove} || qconfig_new+=" ${x}" 636 has ${x} ${qconfig_remove} || qconfig_new+=" ${x}"
552 done 637 done
553 638
554 # replace the existing QT_CONFIG list with qconfig_new 639 # replace the existing QT_CONFIG list with qconfig_new
555 if ! sed -i -e "s/QT_CONFIG +=.*/QT_CONFIG += ${qconfig_new}/" \ 640 if ! sed -i -e "s/QT_CONFIG +=.*/QT_CONFIG += ${qconfig_new}/" \
556 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri; then 641 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri; then
580 fi 665 fi
581 fi 666 fi
582} 667}
583 668
584# @FUNCTION: qt4-build_pkg_postrm 669# @FUNCTION: qt4-build_pkg_postrm
670# @DESCRIPTION:
585# @DESCRIPTION: Generate configurations when the package is completely removed 671# Regenerate configuration when the package is completely removed.
586qt4-build_pkg_postrm() { 672qt4-build_pkg_postrm() {
587 generate_qconfigs 673 generate_qconfigs
588} 674}
589 675
590# @FUNCTION: qt4-build_pkg_postinst 676# @FUNCTION: qt4-build_pkg_postinst
677# @DESCRIPTION:
591# @DESCRIPTION: Generate configuration, plus throws a message about possible 678# Regenerate configuration, plus throw a message about possible
592# breakages and proposed solutions. 679# breakages and proposed solutions.
593qt4-build_pkg_postinst() { 680qt4-build_pkg_postinst() {
594 generate_qconfigs 681 generate_qconfigs
595} 682}
596 683
597# @FUNCTION: skip_qmake_build_patch 684# @FUNCTION: skip_qmake_build
685# @INTERNAL
598# @DESCRIPTION: 686# @DESCRIPTION:
599# Don't need to build qmake, as it's already installed from qt-core 687# Patches configure to skip qmake compilation, as it's already installed by qt-core.
600skip_qmake_build_patch() { 688skip_qmake_build() {
601 # Don't need to build qmake, as it's already installed from qt-core
602 sed -i -e "s:if true:if false:g" "${S}"/configure || die "Sed failed" 689 sed -i -e "s:if true:if false:g" "${S}"/configure || die
603} 690}
604 691
605# @FUNCTION: skip_project_generation_patch 692# @FUNCTION: skip_project_generation
693# @INTERNAL
606# @DESCRIPTION: 694# @DESCRIPTION:
607# Exit the script early by throwing in an exit before all of the .pro files are scanned 695# Exit the script early by throwing in an exit before all of the .pro files are scanned.
608skip_project_generation_patch() { 696skip_project_generation() {
609 # Exit the script early by throwing in an exit before all of the .pro files are scanned
610 sed -e "s:echo \"Finding:exit 0\n\necho \"Finding:g" \ 697 sed -i -e "s:echo \"Finding:exit 0\n\necho \"Finding:g" "${S}"/configure || die
611 -i "${S}"/configure || die "Sed failed"
612} 698}
613 699
614# @FUNCTION: symlink_binaries_to_buildtree 700# @FUNCTION: symlink_binaries_to_buildtree
701# @INTERNAL
615# @DESCRIPTION: 702# @DESCRIPTION:
616# Symlink generated binaries to buildtree so they can be used during compilation 703# Symlinks generated binaries to buildtree, so they can be used during compilation time.
617# time
618symlink_binaries_to_buildtree() { 704symlink_binaries_to_buildtree() {
619 for bin in qmake moc uic rcc; do 705 for bin in qmake moc uic rcc; do
620 ln -s ${QTBINDIR}/${bin} "${S}"/bin/ || die "Symlinking ${bin} to ${S}/bin failed." 706 ln -s "${QTBINDIR}"/${bin} "${S}"/bin/ || die "symlinking ${bin} to ${S}/bin failed"
621 done 707 done
622} 708}
623 709
624# @FUNCTION: fix_library_files 710# @FUNCTION: fix_library_files
711# @INTERNAL
625# @DESCRIPTION: 712# @DESCRIPTION:
626# Fixes the pathes in *.la, *.prl, *.pc, as they are wrong due to sandbox and 713# Fixes the paths in *.la, *.prl, *.pc, as they are wrong due to sandbox and
627# moves the *.pc-files into the pkgconfig directory 714# moves the *.pc files into the pkgconfig directory.
628fix_library_files() { 715fix_library_files() {
716 local libfile
629 for libfile in "${D}"/${QTLIBDIR}/{*.la,*.prl,pkgconfig/*.pc}; do 717 for libfile in "${D}"/${QTLIBDIR}/{*.la,*.prl,pkgconfig/*.pc}; do
630 if [[ -e ${libfile} ]]; then 718 if [[ -e ${libfile} ]]; then
631 sed -i -e "s:${S}/lib:${QTLIBDIR}:g" ${libfile} || die "Sed on ${libfile} failed." 719 sed -i -e "s:${S}/lib:${QTLIBDIR}:g" ${libfile} || die "sed on ${libfile} failed"
632 fi 720 fi
633 done 721 done
634 722
635 # pkgconfig files refer to WORKDIR/bin as the moc and uic locations. Fix: 723 # pkgconfig files refer to WORKDIR/bin as the moc and uic locations
636 for libfile in "${D}"/${QTLIBDIR}/pkgconfig/*.pc; do 724 for libfile in "${D}"/${QTLIBDIR}/pkgconfig/*.pc; do
637 if [[ -e ${libfile} ]]; then 725 if [[ -e ${libfile} ]]; then
638 sed -i -e "s:${S}/bin:${QTBINDIR}:g" ${libfile} || die "Sed failed" 726 sed -i -e "s:${S}/bin:${QTBINDIR}:g" ${libfile} || die "sed on ${libfile} failed"
639 727
640 # Move .pc files into the pkgconfig directory 728 # Move .pc files into the pkgconfig directory
641 dodir ${QTPCDIR#${EPREFIX}} 729 dodir ${QTPCDIR#${EPREFIX}}
642 mv ${libfile} "${D}"/${QTPCDIR}/ \ 730 mv ${libfile} "${D}"/${QTPCDIR}/ || die "moving ${libfile} to ${D}/${QTPCDIR}/ failed"
643 || die "Moving ${libfile} to ${D}/${QTPCDIR}/ failed."
644 fi 731 fi
645 done 732 done
646 733
647 # Don't install an empty directory 734 # Don't install an empty directory
648 rmdir "${D}"/${QTLIBDIR}/pkgconfig 735 rmdir "${D}"/${QTLIBDIR}/pkgconfig
649} 736}
650 737
651# @FUNCTION: qt_use 738# @FUNCTION: qt_use
652# @USAGE: < flag > [ feature ] [ enableval ] 739# @USAGE: < flag > [ feature ] [ enableval ]
653# @DESCRIPTION: 740# @DESCRIPTION:
654# This will echo "${enableval}-${feature}" if <flag> is enabled, or 741# This will echo "-${enableval}-${feature}" if <flag> is enabled, or
655# "-no-${feature} if the flag is disabled. If [feature] is not specified <flag> 742# "-no-${feature}" if it's disabled. If [feature] is not specified, <flag>
656# will be used for that. If [enableval] is not specified, it omits the 743# will be used for that. If [enableval] is not specified, it omits the
657# assignment-part 744# "-${enableval}" part.
658qt_use() { 745qt_use() {
659 local flag=$1 746 use "$1" && echo "${3:+-$3}-${2:-$1}" || echo "-no-${2:-$1}"
660 local feature=$1
661 local enableval=
662
663 [[ -n $2 ]] && feature=$2
664 [[ -n $3 ]] && enableval=-$3
665
666 if use ${flag}; then
667 echo "${enableval}-${feature}"
668 else
669 echo "-no-${feature}"
670 fi
671} 747}
672 748
673# @FUNCTION: qt_mkspecs_dir 749# @FUNCTION: qt_mkspecs_dir
674# @RETURN: the specs-directory w/o path 750# @RETURN: the specs-directory w/o path
675# @DESCRIPTION: 751# @DESCRIPTION:
676# Allows us to define which mkspecs dir we want to use. 752# Allows us to define which mkspecs dir we want to use.
677qt_mkspecs_dir() { 753qt_mkspecs_dir() {
678 # Allows us to define which mkspecs dir we want to use.
679 local spec 754 local spec=
680
681 case ${CHOST} in 755 case ${CHOST} in
682 *-freebsd*|*-dragonfly*) 756 *-freebsd*|*-dragonfly*)
683 spec=freebsd ;; 757 spec=freebsd ;;
684 *-openbsd*) 758 *-openbsd*)
685 spec=openbsd ;; 759 spec=openbsd ;;
697 *-solaris*) 771 *-solaris*)
698 spec=solaris ;; 772 spec=solaris ;;
699 *-linux-*|*-linux) 773 *-linux-*|*-linux)
700 spec=linux ;; 774 spec=linux ;;
701 *) 775 *)
702 die "Unknown CHOST, no platform choosen." 776 die "Unknown CHOST, no platform chosen"
703 esac 777 esac
704 778
705 CXX=$(tc-getCXX) 779 CXX=$(tc-getCXX)
706 if [[ ${CXX} == *g++* ]]; then 780 if [[ ${CXX} == *g++* ]]; then
707 spec+=-g++ 781 spec+=-g++
708 elif [[ ${CXX} == *icpc* ]]; then 782 elif [[ ${CXX} == *icpc* ]]; then
709 spec+=-icc 783 spec+=-icc
710 else 784 else
711 die "Unknown compiler ${CXX}." 785 die "Unknown compiler '${CXX}'"
712 fi
713 if [[ -n ${LIBDIR/lib} ]]; then
714 spec+=-${LIBDIR/lib}
715 fi 786 fi
716 787
717 # Add -64 for 64bit profiles 788 # Add -64 for 64bit profiles
718 if use x64-freebsd || 789 if use x64-freebsd ||
719 use amd64-linux || 790 use amd64-linux ||
725 fi 796 fi
726 797
727 echo "${spec}" 798 echo "${spec}"
728} 799}
729 800
801# @FUNCTION: qt_assistant_cleanup
802# @INTERNAL
803# @DESCRIPTION:
804# Tries to clean up tools.pro for qt-assistant ebuilds.
805# Meant to be called in src_prepare().
806# Since Qt 4.7.4 this function is a no-op.
807qt_assistant_cleanup() {
808 # apply patching to qt-assistant ebuilds only
809 [[ ${PN} != "qt-assistant" ]] && return
810
811 # no longer needed for 4.7.4 and later
812 version_is_at_least "4.7.4" && return
813
814 # different versions (and branches...) may need different handling,
815 # add a case if you need special handling
816 case "${MY_PV_EXTRA}" in
817 *kde-qt*)
818 sed -e "/^[ \t]*porting/,/^[ \t]*win32.*activeqt$/d" \
819 -e "/mac/,/^embedded.*makeqpf$/d" \
820 -i tools/tools.pro || die "patching tools.pro failed"
821 ;;
822 *)
823 sed -e "/^[ \t]*porting/,/^[ \t]*win32.*activeqt$/d" \
824 -e "/mac/,/^embedded.*makeqpf$/d" \
825 -e "s/^\([ \t]*pixeltool\) /\1 qdoc3 /" \
826 -i tools/tools.pro || die "patching tools.pro failed"
827 ;;
828 esac
829}
830
831# @FUNCTION: qt_nolibx11
832# @INTERNAL
833# @DESCRIPTION:
834# Ignore X11 tests for packages that don't need X libraries installed.
835qt_nolibx11() {
836 sed -i "/unixtests\/compile.test.*config.tests\/x11\/xlib/,/fi$/d" "${S}"/configure ||
837 die "x11 check sed failed"
838}
839
730EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_install pkg_postrm pkg_postinst 840EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_install src_test pkg_postrm pkg_postinst

Legend:
Removed from v.1.68  
changed lines
  Added in v.1.120

  ViewVC Help
Powered by ViewVC 1.1.20